package examples.addressbook;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class GetName extends ActorReference  {
	public GetName selfReference;

	public GetName(UAN uan) { super(uan); }
	public GetName(UAL ual) { super(ual); }

	public static void main(String args[]) {
		GetName instance = new GetName();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public GetName() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected GetName self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public void act(String args[]) {
			if (args.length != 2) {
				{
					// standardOutput<-println("Usage: java examples.addressbook.GetName <AddressBookUAN> <Email>")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java examples.addressbook.GetName <AddressBookUAN> <Email>" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				return;
			}
			{
				// getName(args[0], args[1])
				{
					Message message = new Message( self, self, "getName", null );
					Object _arguments[] = { args[0], args[1] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void getName(String uan, String email) {
			try {
				AddressBook book = new AddressBook(new UAN(uan));
				{
					Token token_3_0 = new Token();
					Token token_3_1 = new Token();
					// standardOutput<-print(email + " is: ")
					{
						Message message = new Message( self, standardOutput, "print", token_3_0.createInput() );
						Object _arguments[] = { email + " is: " };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// book<-getName(email)
					{
						Message message = new Message( self, book, "getName", token_3_1.createInput() );
						Object _arguments[] = { email };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(book, message, -1) );
						messages.add( message );
					}
					// standardOutput<-println(token)
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { token_3_1.createOutput(standardOutput, message, 0) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 1 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			catch (MalformedUANException e) {
				{
					// standardError<-println("bad addressbook UAN")
					{
						Message message = new Message( self, standardError, "println", null );
						Object _arguments[] = { "bad addressbook UAN" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				return;
			}

		}
	}
}