package examples.fibonacci;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Fibonacci extends ActorReference  {
	public Fibonacci selfReference;

	public Fibonacci(UAN uan) { super(uan); }
	public Fibonacci(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Fibonacci instance = new Fibonacci();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Fibonacci(int n) {
		selfReference = this;
		State state = new State(n);
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public Fibonacci() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Fibonacci self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		int n;
		State(int n) {
			self.ual = __ual;
			Vector messages = new Vector();

			this.n = n;
			ServiceFactory.getTransport().send(messages);
		}
		public int add(int x, int y) {
			return x + y;
		}
		public int compute() {
			if (n == 0) 			return 0;
			else if (n <= 2) 			return 1;
			else {
				Fibonacci fib1 = new Fibonacci(n - 1);
				Fibonacci fib2 = new Fibonacci(n - 2);
				Token x = new Token("x");
				{
					// token x = fib1<-compute()
					{
						Message message = new Message( self, fib1, "compute", x.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				Token y = new Token("y");
				{
					// token y = fib2<-compute()
					{
						Message message = new Message( self, fib2, "compute", y.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				{
					// add(x, y)
					{
						Message message = new Message( self, self, "add", currentContinuation );
						Object _arguments[] = { x.createOutput(self, message, 0), y.createOutput(self, message, 1) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 2 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
		public void act(String args[]) {
			n = Integer.parseInt(args[0]);
			{
				Token token_2_0 = new Token();
				// compute()
				{
					Message message = new Message( self, self, "compute", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-println(token)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { token_2_0.createOutput(standardOutput, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}