package examples.heat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.io.*;
public class HeatWorker extends ActorReference  {
	public HeatWorker selfReference;

	public HeatWorker(UAN uan) { super(uan); }
	public HeatWorker(UAL ual) { super(ual); }

	public static void main(String args[]) {
		HeatWorker instance = new HeatWorker();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public HeatWorker(double[][] inData) {
		selfReference = this;
		State state = new State(inData);
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public HeatWorker() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected HeatWorker self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		int x;
		int y;
		double[][] data;
		double[][] next;
		HeatWorker top;
		HeatWorker bottom;
		boolean topOk = false;
		boolean bottomOk = false;
		State(double[][] inData) {
			self.ual = __ual;
			Vector messages = new Vector();

			x = inData.length + 2;
			y = inData[0].length;
			data = new double[x][];
			data[0] = new double[y];
			data[x - 1] = new double[y];
			for (int j = 0; j < y; j++){
				data[0][j] = data[x - 1][j]=-1;
			}
			for (int i = 0; i < x - 2; i++){
				data[i + 1] = new double[y];
				System.arraycopy(inData[i], 0, data[i + 1], 0, y);
			}
			next = new double[x][];
			for (int i = 0; i < x; i++){
				next[i] = new double[y];
				System.arraycopy(data[i], 0, next[i], 0, y);
			}
			ServiceFactory.getTransport().send(messages);
		}
		public void connectTop(HeatWorker w) {
			top = w;
			{
				// top<-bottomRow(data[0])
				{
					Message message = new Message( self, top, "bottomRow", null );
					Object _arguments[] = { data[0] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void connectBottom(HeatWorker w) {
			bottom = w;
			{
				// bottom<-topRow(data[x - 1])
				{
					Message message = new Message( self, bottom, "topRow", null );
					Object _arguments[] = { data[x - 1] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void topRow(double[] row) {
			System.arraycopy(row, 0, data[0], 0, y);
			topOk = true;
		}
		public void bottomRow(double[] row) {
			System.arraycopy(row, 0, data[x - 1], 0, y);
			bottomOk = true;
		}
		public double[][] doWork(int iterations) {
			if (((bottom == null) || (bottomOk)) && ((top == null) || (topOk))) {
				int from = (top == null ? 2 : 1);
				int to = (bottom == null ? x - 2 : x - 1);
				for (int i = from; i < to; i++)for (int j = 1; j < y - 1; j++)next[i][j] = 0.25 * (data[i - 1][j] + data[i][j - 1] + data[i + 1][j] + data[i][j + 1]);
				double[][] temp = next;
				next = data;
				data = temp;
				if (top != null) 				{
					// top<-bottomRow(data[0])
					{
						Message message = new Message( self, top, "bottomRow", null );
						Object _arguments[] = { data[0] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				if (bottom != null) 				{
					// bottom<-topRow(data[x - 1])
					{
						Message message = new Message( self, bottom, "topRow", null );
						Object _arguments[] = { data[x - 1] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				topOk = false;
				bottomOk = false;
				if (iterations == 0) {
					double[][] results = new double[x - 2][];
					System.arraycopy(data, 1, results, 0, x - 2);
					return results;
				}
				else {
					{
						// doWork(new Integer(iterations - 1))
						{
							Message message = new Message( self, self, "doWork", currentContinuation );
							Object _arguments[] = { new Integer(iterations - 1) };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
						currentContinuation = null;
						throw new CurrentContinuationException();
					}
				}
			}
			else {
				{
					// doWork(new Integer(iterations))
					{
						Message message = new Message( self, self, "doWork", currentContinuation );
						Object _arguments[] = { new Integer(iterations) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
	}
}