package examples.multicast;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class GlobalKnowledgeMulticast extends ActorReference  {
	public GlobalKnowledgeMulticast selfReference;

	public GlobalKnowledgeMulticast(UAN uan) { super(uan); }
	public GlobalKnowledgeMulticast(UAL ual) { super(ual); }

	public static void main(String args[]) {
		GlobalKnowledgeMulticast instance = new GlobalKnowledgeMulticast();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public GlobalKnowledgeMulticast() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected GlobalKnowledgeMulticast self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		AwareActor[] actors;
		long initialTime;
		public long ack() {
			return System.currentTimeMillis() - initialTime;
		}
		public void act(String args[]) {
			int howMany = Integer.parseInt(args[0]);
			AwareActor[] actors = new AwareActor[howMany];
			for (int i = 0; i < howMany; i++){
				actors[i] = new AwareActor();
			}
			initialTime = System.currentTimeMillis();
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				Token token_2_4 = new Token();
				// standardOutput<-print("Time for global knowledge multicast: ")
				{
					Message message = new Message( self, standardOutput, "print", token_2_0.createInput() );
					Object _arguments[] = { "Time for global knowledge multicast: " };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// join block
				token_2_1.setJoinToken();
				for (int i = 0; i < howMany; i++)				{
					// actors[i]<-m()
					{
						Message message = new Message( self, actors[i], "m", token_2_1.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_2_0.createOutput(actors[i], message, -1) );
						messages.add( message );
					}
				}
				// join block
				token_2_2.setJoinToken();
				for (int i = 0; i < howMany; i++)				{
					// actors[i]<-ok()
					{
						Message message = new Message( self, actors[i], "ok", token_2_2.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_2_1.createOutput(actors[i], message, -1) );
						messages.add( message );
					}
				}
				// ack()
				{
					Message message = new Message( self, self, "ack", token_2_3.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_2.createOutput(self, message, -1) );
					messages.add( message );
				}
				// standardOutput<-print(token)
				{
					Message message = new Message( self, standardOutput, "print", token_2_4.createInput() );
					Object _arguments[] = { token_2_3.createOutput(standardOutput, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-println(" ms.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { " ms." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_4.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}