package examples.trap;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.io.*;
import java.util.*;
public class Trap extends ActorReference  {
	public Trap selfReference;

	public Trap(UAN uan) { super(uan); }
	public Trap(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Trap instance = new Trap();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Trap() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Trap self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		int noActors = 2;
		double a = 0.0;
		double b = 1.0;
		int n = 1024;
		long initialTime;
		String nameServer = "jupiter.wcl.cs.rpi.edu";
		String theatersFile = "theaters.txt";
		public void act(String args[]) {
			int argc = args.length;
			if (argc >= 1) a = Double.valueOf(args[0]).doubleValue();
			if (argc >= 2) b = Double.valueOf(args[1]).doubleValue();
			if (argc >= 3) n = Integer.parseInt(args[2]);
			if (argc >= 4) noActors = Integer.parseInt(args[3]);
			if (argc >= 5) nameServer = args[4];
			if (argc >= 6) theatersFile = args[5];
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// DistributeWork()
				{
					Message message = new Message( self, self, "DistributeWork", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// displayResults(token)
				{
					Message message = new Message( self, self, "displayResults", token_2_1.createInput() );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// endTimer()
				{
					Message message = new Message( self, self, "endTimer", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
		}
		public double[][] DistributeWork() {
			Double h = new Double((b - a) / n);
			Integer local_n = new Integer((int) (n / noActors));
			Double local_a;
			Double local_b;
			TrapWorker[] workers = new TrapWorker[noActors];
			for (int i = 0; i < noActors; i++){
				workers[i] = new TrapWorker();
			}
			Vector theaters = new Vector();
			String theater;
			try {
				BufferedReader in = new BufferedReader(new FileReader(theatersFile));
				while ((theater=in.readLine()) != null) {
					theaters.add(theater);
				}
				in.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file " + theatersFile + " for reading.")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "[error] Can't open the file " + theatersFile + " for reading." };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

			for (int i = 0; i < noActors; i++){
				{
					// standardOutput<-println("Sending actor " + "uan://" + nameServer + ":3030/a" + i + " to " + "rmsp://" + theaters.get(i % theaters.size()) + "/a" + i)
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Sending actor " + "uan://" + nameServer + ":3030/a" + i + " to " + "rmsp://" + theaters.get(i % theaters.size()) + "/a" + i };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				{
					// workers[i]<-bind("uan://" + nameServer + ":3030/a" + i, "rmsp://" + theaters.get(i % theaters.size()) + "/a" + i)
					{
						Message message = new Message( self, workers[i], "bind", null );
						Object _arguments[] = { "uan://" + nameServer + ":3030/a" + i, "rmsp://" + theaters.get(i % theaters.size()) + "/a" + i };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			{
				// standardOutput<-println(">>>>>>Starting the computation")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { ">>>>>>Starting the computation" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			initialTime = System.currentTimeMillis();
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinToken();
				for (int i = 0; i < noActors; i++){
					System.out.println("sending work to worker " + i);
					local_a = new Double(a + i * local_n.doubleValue() * h.doubleValue());
					local_b = new Double(local_a.doubleValue() + local_n.doubleValue() * h.doubleValue());
					{
						// workers[i]<-trap(local_a, local_b, local_n, h)
						{
							Message message = new Message( self, workers[i], "trap", token_2_0.createInput() );
							Object _arguments[] = { local_a, local_b, local_n, h };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
					}
				}
				// addUpIntegrals(token)
				{
					Message message = new Message( self, self, "addUpIntegrals", currentContinuation );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public void endTimer() {
			long finalTime = System.currentTimeMillis();
			long runningTime = finalTime - initialTime;
			{
				// standardOutput<-println("Running time for Trapezoidal approximation is " + runningTime + " ms.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Running time for Trapezoidal approximation is " + runningTime + " ms." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public Double addUpIntegrals(Object[] results) {
			double total = 0.0;
			for (int i = 0; i < results.length; i++){
				total += ((Double) results[i]).doubleValue();
			}
			return new Double(total);
		}
		public void displayResults(Double result) {
			{
				// standardOutput<-println("With n = " + n + " trapezoids, our estimate of the integral on (" + a + "," + b + ") =" + result.doubleValue() + "with error " + (result.doubleValue() - 1.0e0))
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "With n = " + n + " trapezoids, our estimate of the integral on (" + a + "," + b + ") =" + result.doubleValue() + "with error " + (result.doubleValue() - 1.0e0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}