package io;

import io.core.agents.ProfilingAgent;
import salsa.language.ActorReference;
import salsa.language.exceptions.SalsaWrapperException;
import wwc.messaging.Theater;

public class IOTheater extends Theater {
	static ActorReference decisionActor = null;
	static ActorReference protocolActor = null;
	static ProfilingAgent profilingAgent = null;


	public static synchronized ActorReference getDecisionActor() {
		if (decisionActor == null) {
			//Check for the decision actor
			//default = io.ars.ARSDecisionActor
			String className = System.getProperty( "decision" );  
			if (className == null) className = "io.ars.ARSDecisionActor";

			try {
				decisionActor = (ActorReference)Class.forName( className ).newInstance();
			} catch (Exception e) {
				throw new SalsaWrapperException( "Exception creating the IO decision actor.", e );
			}
		}
		return decisionActor;
	}

	public static synchronized ActorReference getProtocolActor() {
		if (protocolActor == null) {
			//Check for the protocol actor
			//default = io.ars.ARSProtocolActor
			String className = System.getProperty( "protocol" );  
			if (className == null) className = "io.ars.ARSProtocolActor";

			try {
				protocolActor = (ActorReference)Class.forName( className ).newInstance();
			} catch (Exception e) {
				throw new SalsaWrapperException( "Exception creating the IO protocol actor.", e );
			}
		}
		return protocolActor;
	}

	public static synchronized ProfilingAgent getProfilingAgent() {
		if (profilingAgent == null) {
			//Check for the profiling agent
			//default = io.ars.ARSProfilingAgent
			String className = System.getProperty( "profiling" );  
			if (className == null) className = "io.ars.ARSProfilingAgent";

			try {
				profilingAgent = (ProfilingAgent)Class.forName( className ).newInstance();
			} catch (Exception e) {
				throw new SalsaWrapperException( "Exception creating the IO profiling agent.", e );
			}
		}
		return profilingAgent;
	}

	public IOTheater() {
		String[] args = { "0" };
                Theater.main(args);

		getProfilingAgent();
		getDecisionActor();
		getProtocolActor();
	}

	public static void main(String[] arguments) {
		Theater.main(arguments);

		getProfilingAgent();
		getDecisionActor();
		getProtocolActor();
	}
}
