package io.core.language;

import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.naming.UAN;
import salsa.naming.UAL;

import io.IOTheater;
import io.core.agents.ProfilingAgent;

public class AutonomousActorReference extends ActorReference {
	private transient ProfilingAgent profilingAgent;

	public AutonomousActorReference() {
		super();
		profilingAgent = IOTheater.getProfilingAgent();
	}

	public AutonomousActorReference(UAN _uan) {
		super(_uan);
		profilingAgent = IOTheater.getProfilingAgent();
	}

	public AutonomousActorReference(UAL _ual) {
		super(_ual);
		profilingAgent = IOTheater.getProfilingAgent();
	}

	private String getIdentifier() {
		if (uan == null) 	return ual.toString();
		else 			return uan.toString();
	}

	public void send(Message message) {
		profilingAgent.beginSend(getIdentifier(), message);
		super.send(message);
		profilingAgent.endSend(getIdentifier(), message);
	}

	private void writeObject(java.io.ObjectOutputStream out) throws Exception {
		out.defaultWriteObject();
	}

	private void readObject(java.io.ObjectInputStream in) throws Exception {
		in.defaultReadObject();

		profilingAgent = IOTheater.getProfilingAgent();
	}
}
