package io.testing.benchmarks;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.util.Vector;
import io.core.language.*;
public class Node extends AutonomousActorReference {
	public Node selfReference;

	public Node(UAN uan) { super(uan); }
	public Node(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Node instance = new Node();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Node(int _messageSendingDelay, int _messageSize, int _processingValue) {
		selfReference = this;
		State state = new State(_messageSendingDelay, _messageSize, _processingValue);
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public Node() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends AutonomousActor {
		protected Node self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		Vector references;
		int messageSize;
		int messageSendingDelay;
		int processingValue;
		int computes;
		State(int _messageSendingDelay, int _messageSize, int _processingValue) {
			self.ual = __ual;
			Vector messages = new Vector();

			references = new Vector();
			messageSize = _messageSize;
			messageSendingDelay = _messageSendingDelay;
			processingValue = _processingValue;
			computes = 0;
			ServiceFactory.getTransport().send(messages);
		}
		public void receivedRemoteCompute() {
			computes++;
			if (computes >= references.size()) {
				computes = 0;
				{
					// iterate(new Byte[messageSize])
					{
						Message message = new Message( self, self, "iterate", null );
						Object _arguments[] = { new Byte[messageSize] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
		}
		public void addReference(Node reference) {
			references.add(reference);
		}
		public void process(Byte[] b) {
			for (int i = 0; i < processingValue; i++){
				double dummy = java.lang.Math.pow(1234.56789, 123.4567);
			}
		}
		public void iterate(Byte[] b) {
			for (int i = 0; i < processingValue; i++){
				double dummy = java.lang.Math.pow(1234.56789, 123.4567);
			}
			Node[] targetNodes = new Node[references.size()];
			for (int i = 0; i < references.size(); i++){
				targetNodes[i] = (Node) references.get(i);
			}
			for (int j = 0; j < targetNodes.length; j++){
				{
					Token token_3_0 = new Token();
					// targetNodes[j]<-process(b)
					{
						Message message = new Message( self, targetNodes[j], "process", token_3_0.createInput() );
						Object _arguments[] = { b };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// receivedRemoteCompute()
					{
						Message message = new Message( self, self, "receivedRemoteCompute", null );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(self, message, -1) );
						messages.add( message );
					}
				}
			}
		}
		public void startSending() {
			{
				// iterate(new Byte[messageSize])
				{
					Message message = new Message( self, self, "iterate", null );
					Object _arguments[] = { new Byte[messageSize] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}