package io.testing.benchmarks;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.io.FileInputStream;
import java.util.Vector;
import java.util.StringTokenizer;
public class Unconnected extends ActorReference  {
	public Unconnected selfReference;

	public Unconnected(UAN uan) { super(uan); }
	public Unconnected(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Unconnected instance = new Unconnected();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Unconnected() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Unconnected self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		int size;
		int messageSendingDelay;
		int messageSize;
		int processingTime;
		String nameServer;
		Vector theaters;
		Node[] nodes;
		int nodeCount;
		public void printTheaters(int counter) {
			System.out.println("inside printTheaters with counter = " + counter);
			if (counter < theaters.size()) {
				{
					Token token_3_0 = new Token();
					// printTheaters(new Integer(counter + 1))
					{
						Message message = new Message( self, self, "printTheaters", token_3_0.createInput() );
						Object _arguments[] = { new Integer(counter + 1) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// standardOutput<-println("\t" + (String) theaters.get(counter))
					{
						Message message = new Message( self, standardOutput, "println", currentContinuation );
						Object _arguments[] = { "\t" + (String) theaters.get(counter) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(standardOutput, message, -1) );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
			else {
				{
					// standardOutput<-print("")
					{
						Message message = new Message( self, standardOutput, "print", currentContinuation );
						Object _arguments[] = { "" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
		public void generateNodes() {
			nodes = new Node[(int) nodeCount];
			for (int i = 0; i < nodeCount; i++){
				nodes[i] = new Node(messageSendingDelay, messageSize, processingTime);
			}
		}
		public void generateLinks(int i) {
			if (i < nodeCount) {
				{
					Token token_3_0 = new Token();
					// generateLinks(new Integer(i + 1))
					{
						Message message = new Message( self, self, "generateLinks", token_3_0.createInput() );
						Object _arguments[] = { new Integer(i + 1) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// nodes[i]<-addReference(nodes[i])
					{
						Message message = new Message( self, nodes[i], "addReference", currentContinuation );
						Object _arguments[] = { nodes[i] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(nodes[i], message, -1) );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
			else {
				{
					// standardOutput<-print("")
					{
						Message message = new Message( self, standardOutput, "print", currentContinuation );
						Object _arguments[] = { "" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
		public void bindActors(int i, int theaterNum) {
			if (i < nodeCount) {
				if (theaterNum >= theaters.size()) theaterNum = 0;
				{
					Token token_3_0 = new Token();
					// bindActors(new Integer(i + 1), new Integer(theaterNum + 1))
					{
						Message message = new Message( self, self, "bindActors", token_3_0.createInput() );
						Object _arguments[] = { new Integer(i + 1), new Integer(theaterNum + 1) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// nodes[i]<-bind(new String(nameServer + "tree_node_" + i), new String((String) theaters.get(theaterNum) + "tree_node_" + i))
					{
						Message message = new Message( self, nodes[i], "bind", currentContinuation );
						Object _arguments[] = { new String(nameServer + "tree_node_" + i), new String((String) theaters.get(theaterNum) + "tree_node_" + i) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(nodes[i], message, -1) );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
			else {
				{
					// standardOutput<-print("")
					{
						Message message = new Message( self, standardOutput, "print", currentContinuation );
						Object _arguments[] = { "" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
		public void startComputation(int i) {
			if (i < nodeCount) {
				{
					Token token_3_0 = new Token();
					// startComputation(new Integer(i + 1))
					{
						Message message = new Message( self, self, "startComputation", token_3_0.createInput() );
						Object _arguments[] = { new Integer(i + 1) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// nodes[i]<-startSending()
					{
						Message message = new Message( self, nodes[i], "startSending", currentContinuation );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(nodes[i], message, -1) );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
			else {
				{
					// standardOutput<-print("")
					{
						Message message = new Message( self, standardOutput, "print", currentContinuation );
						Object _arguments[] = { "" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
		public void act(String[] arguments) {
			try {
				if (arguments.length != 5) {
					System.err.println("Usage: ");
					System.err.println("\tjava io.testing.benchmarks.Unconnected <naming/theater information file> " + "<size> <messageSendingDelay(ms)> <messageSize(bytes)> <processingTime(ms)>");
					System.exit(0);
				}
				theaters = new Vector();
				FileInputStream file;
				byte input[];
				try {
					file = new FileInputStream(arguments[0]);
					input = new byte[file.available()];
					file.read(input);
					StringTokenizer st = new StringTokenizer(new String(input), "\n");
					nameServer = st.nextToken();
					while (st.hasMoreTokens()) {
						theaters.add(st.nextToken());
					}
				}
				catch (Exception e) {
					System.err.println("Error reading naming/theater information file: " + e);
					System.exit(0);
				}

				size = new Integer(arguments[1]).intValue();
				messageSendingDelay = new Integer(arguments[2]).intValue();
				messageSize = new Integer(arguments[3]).intValue();
				processingTime = new Integer(arguments[4]).intValue();
			}
			catch (Exception e) {
				System.err.println("Usage: ");
				System.err.println("\tjava io.testing.benchmarks.Unconnected <naming/theater information file> " + "<nodes> <messageSendingDelay(ms)> <messageSize(bytes)> <processingTime(ms)>");
				System.exit(0);
			}

			nodeCount = size;
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				Token token_2_4 = new Token();
				Token token_2_5 = new Token();
				Token token_2_6 = new Token();
				Token token_2_7 = new Token();
				Token token_2_8 = new Token();
				Token token_2_9 = new Token();
				Token token_2_10 = new Token();
				Token token_2_11 = new Token();
				Token token_2_12 = new Token();
				Token token_2_13 = new Token();
				Token token_2_14 = new Token();
				Token token_2_15 = new Token();
				Token token_2_16 = new Token();
				Token token_2_17 = new Token();
				Token token_2_18 = new Token();
				// standardOutput<-println("Creating a unconnected actor graph with: ")
				{
					Message message = new Message( self, standardOutput, "println", token_2_0.createInput() );
					Object _arguments[] = { "Creating a unconnected actor graph with: " };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-println("\tnodes in unconnected actor graph: " + nodeCount)
				{
					Message message = new Message( self, standardOutput, "println", token_2_1.createInput() );
					Object _arguments[] = { "\tnodes in unconnected actor graph: " + nodeCount };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("\tdelay between message sends: " + messageSendingDelay + "(ms)")
				{
					Message message = new Message( self, standardOutput, "println", token_2_2.createInput() );
					Object _arguments[] = { "\tdelay between message sends: " + messageSendingDelay + "(ms)" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("\tsize of messages: " + messageSize + "(bytes)")
				{
					Message message = new Message( self, standardOutput, "println", token_2_3.createInput() );
					Object _arguments[] = { "\tsize of messages: " + messageSize + "(bytes)" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_2.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("\tprocessing intensity of a message: " + processingTime + "(ms)")
				{
					Message message = new Message( self, standardOutput, "println", token_2_4.createInput() );
					Object _arguments[] = { "\tprocessing intensity of a message: " + processingTime + "(ms)" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_3.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println()
				{
					Message message = new Message( self, standardOutput, "println", token_2_5.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_4.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("Using name server:")
				{
					Message message = new Message( self, standardOutput, "println", token_2_6.createInput() );
					Object _arguments[] = { "Using name server:" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_5.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("\t" + nameServer)
				{
					Message message = new Message( self, standardOutput, "println", token_2_7.createInput() );
					Object _arguments[] = { "\t" + nameServer };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_6.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("Loading actor graph randomly on theater(s): ")
				{
					Message message = new Message( self, standardOutput, "println", token_2_8.createInput() );
					Object _arguments[] = { "Loading actor graph randomly on theater(s): " };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_7.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// printTheaters(0)
				{
					Message message = new Message( self, self, "printTheaters", token_2_9.createInput() );
					Object _arguments[] = { new Integer(0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_8.createOutput(self, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println()
				{
					Message message = new Message( self, standardOutput, "println", token_2_10.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_9.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("Generating nodes...")
				{
					Message message = new Message( self, standardOutput, "println", token_2_11.createInput() );
					Object _arguments[] = { "Generating nodes..." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_10.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// generateNodes()
				{
					Message message = new Message( self, self, "generateNodes", token_2_12.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_11.createOutput(self, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("Binding actors...")
				{
					Message message = new Message( self, standardOutput, "println", token_2_13.createInput() );
					Object _arguments[] = { "Binding actors..." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_12.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// bindActors(0, 0)
				{
					Message message = new Message( self, self, "bindActors", token_2_14.createInput() );
					Object _arguments[] = { new Integer(0), new Integer(0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_13.createOutput(self, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("Generating links...")
				{
					Message message = new Message( self, standardOutput, "println", token_2_15.createInput() );
					Object _arguments[] = { "Generating links..." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_14.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// generateLinks(0)
				{
					Message message = new Message( self, self, "generateLinks", token_2_16.createInput() );
					Object _arguments[] = { new Integer(0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_15.createOutput(self, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("Starting computation...")
				{
					Message message = new Message( self, standardOutput, "println", token_2_17.createInput() );
					Object _arguments[] = { "Starting computation..." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_16.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
				// startComputation(0)
				{
					Message message = new Message( self, self, "startComputation", token_2_18.createInput() );
					Object _arguments[] = { new Integer(0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_17.createOutput(self, message, -1) );
					messages.add( message );
				}
				// standardOutput<-println("finished.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "finished." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_18.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}