package salsa.resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.net.*;
import java.io.*;
import java.util.Hashtable;
public class StandardDisk extends ActorReference  {
	public StandardDisk selfReference;

	public StandardDisk(UAN uan) { super(uan); }
	public StandardDisk(UAL ual) { super(ual); }

	public static void main(String args[]) {
		StandardDisk instance = new StandardDisk();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public StandardDisk() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected StandardDisk self = selfReference;
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		Hashtable fileNames = new Hashtable();
		Hashtable messagesStored = new Hashtable();
		int generatedFile = 0;
		public  State() {
			self.ual = __ual;
			Vector messages = new Vector();

			ServiceFactory.getTransport().send(messages);
		}
		public void storeActor(Actor actor) {
			String filename = "" + generatedFile;
			fileNames.put(actor.getUAN(), filename);
			messagesStored.put(actor.getUAN(), new Integer(0));
			{
				// store(actor, filename)
				{
					Message message = new Message( self, self, "store", null );
					Object _arguments[] = { actor, filename };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void restoreActor(String filename) {
			Actor actor = (Actor) get(filename);
			Integer messages = (Integer) messagesStored.get(actor.getUAN());
			if (actor == null | messages == null) {
				System.err.println("StandardDisk error:");
				System.err.println("\tRestoring an  unknown target actor");
				System.err.println("\tFrom file: " + filename);
				return;
			}
			for (int i = 0; i < messages.intValue(); i++){
				actor.send((Message) get(filename + "_" + i));
			}
			actor.start();
			fileNames.remove(actor.getUAN());
			messagesStored.remove(actor.getUAN());
		}
		public void storeMessage(Message message) {
			UAN uan = message.getTarget().getUAN();
			if (uan == null) {
			}
			String filename = (String) fileNames.get(uan);
			Integer messageNumber = (Integer) messagesStored.get(uan);
			if (filename == null || messageNumber == null) {
				System.err.println("StandardDisk error:");
				System.err.println("\tStoring a message with an unknown target actor");
				System.err.println("\tMessage will be lost");
				System.err.println("\tMessage: " + message.toString());
				return;
			}
			this.store(message, filename + "_" + messageNumber);
			messagesStored.put(uan, new Integer(messageNumber.intValue() + 1));
		}
		public void store(Object object, String filename) {
			try {
				ObjectOutputStream outStream = new ObjectOutputStream(new FileOutputStream(filename));
				outStream.writeObject(object);
				outStream.close();
			}
			catch (IOException e) {
				System.err.println("StorageHandler exception: ");
				System.err.println("\tError serializing object to file: " + filename);
				System.err.println("\tObject = " + object.toString());
				System.err.println("\t" + e);
			}

		}
		public Object get(String filename) {
			Object object = null;
			try {
				ObjectInputStream inStream = new ObjectInputStream(new FileInputStream(filename));
				inStream.readObject();
				inStream.close();
			}
			catch (IOException e) {
				System.err.println("StandardDisk exception: ");
				System.err.println("\tError serializing object from file: " + filename);
				System.err.println("\t" + e);
			}
			catch (ClassNotFoundException e) {
				System.err.println("StandardDisk exception: ");
				System.err.println("\tObject class not found for: " + filename);
				System.err.println("\t" + e);
			}

			return object;
		}
	}
}