/*
	Code generation for the following grammar segment:
	
	Arguments := "(" [Expression ("," Expression)*] ")"
*/

package salsac.definitions;

import salsac.*;

public class Arguments extends SimpleNode {

	public Arguments(int id) 					{ super(id); }
	public Arguments(SalsaParser p, int id)	{ super(p, id); }

	public String getPropertyCode() {
		String code = "";

		if (children != null) {
			for (int i = 0; i < children.length; i++) {
				code += getChild(i).getJavaCode();
			
				if (i != children.length-1) code += ", ";
			}
		}
		return code;
	}


	public String getJavaCode() {
		String code = "";

		if (children != null) {
			for (int i = 0; i < children.length; i++) {
				code += getChild(i).getJavaCode();
			
				if (i != children.length-1) code += ", ";
			}
		}
		return "(" + code + ")";
	}
}
