/*
	Code generation for the following grammar segment:
	
	BehaviorDeclaration := "behavior" <IDENTIFIER> ["extends" Name()] ["implements" Name() ("," Name())*] BehaviorBody()
*/


package salsac.definitions;

import salsac.*;
import java.util.Vector;

public class BehaviorDeclaration extends SimpleNode {

	public BehaviorDeclaration(int id) 			{ super(id); }
	public BehaviorDeclaration(SalsaParser p, int id)	{ super(p, id); }

	public String extendsName = null;
	public Vector implementNames = new Vector();

	public String getChildCode() {
		String code = "class " + getToken(1);					//"behavior <IDENTIFIER>"

		if (tokens.length == 2 || !getToken(2).image.equals("extends")) {
			code += " extends ActorReference ";
		}

		int i = 2;
		for (; i < tokens.length; i++) {
			if ( getToken(i).image.equals("extends") ) {
				extendsName = getChild(i-2).getJavaCode();
				code += " " + getToken(i).image + " " + getChild(i-2).getJavaCode();
			} else if ( getToken(i).image.equals(",") || getToken(i).image.equals("implements") ) {
				implementNames.add(getChild(i-2).getJavaCode());
			}
		}
		code += " " + getChild(i-2).getJavaCode();

		return code;
	}
}
