/*
	Code generation for the following grammar segment:
	
	InterfaceDeclaration := "interface" <IDENTIFIER> ["extends" Name()] ["implements" Name() ("," Name())*] InterfaceBody()
*/


package salsac.definitions;

import salsac.*;

public class InterfaceDeclaration extends SimpleNode {

	public InterfaceDeclaration(int id) 			{ super(id); }
	public InterfaceDeclaration(SalsaParser p, int id)	{ super(p, id); }

	public String extendsName = null;

	public String getChildCode() {
		String code = "class " + getToken(1);					//"interface <IDENTIFIER>"

		if (tokens.length == 2 || !getToken(2).image.equals("extends")) {
			code += " extends ActorReference ";
		}

		int i = 2;
		for (; i < tokens.length; i++) {
			if ( getToken(i).image.equals("extends") ) extendsName = getChild(i-2).getJavaCode();

			code += " " + getToken(i).image + " " + getChild(i-2).getJavaCode();
		}
		code += " " + getChild(i-2).getJavaCode();

		return code;
	}
}
